#!/bin/bash


if [ -f /etc/os-release ]; then
    . /etc/os-release
fi


ID=$(echo "$ID" | sed -r 's/\"//g')
VER=$(echo "$VERSION_ID" | sed -r 's/\"//g')
VER_TEMP=$(echo "$VER" | sed -r 's/\..*//')


#Переходим на либы без версии в названии (v.4.0)
change_lib()
{
    LIB=/opt/assistant/lib
    echo "Starting update libraries..."
    if [[ -f $LIB/libcurl.so.4.5.0 && -f $LIB/libcurl.so.4.7.0 ]]; then
    	ln -fs $LIB/libcurl.so.4.7.0 $LIB/libcurl.so.4
    	ln -fs $LIB/libcurl.so.4.7.0 $LIB/libcurl.so
	rm $LIB/libcurl.so.4.5.0
    fi

    if [[ -f $LIB/libvpx.so.6.2.0 && ! -L $LIB/libvpx.so ]]; then
    	ln -s $LIB/libvpx.so.6.2.0 $LIB/libvpx.so.6.2
    	ln -s $LIB/libvpx.so.6.2.0 $LIB/libvpx.so.6
    	ln -s $LIB/libvpx.so.6.2.0 $LIB/libvpx.so
    fi

    if [[ -f $LIB/libxkbcommon.so.0.0.0 && ! -L $LIB/libxkbcommon.so ]]; then
    	ln -s $LIB/libxkbcommon.so.0.0.0 $LIB/libxkbcommon.so.0
    	ln -s $LIB/libxkbcommon.so.0.0.0 $LIB/libxkbcommon.so
    fi

    if [[ -f $LIB/libastrct.so.2.5.0 || -f $LIB/libhatls.so.2.5.0 || -f $LIB/libastclient.so.2.5.0 ]];
    then
	rm $LIB/libast*.so.2*
        rm $LIB/libhatls.so.2*
	echo "All libraries have updated"
    else
        echo "Old libraries not found"
    fi
}

TYPE='assistant'
[[ -d /usr/share/cassistantd ]] && TYPE='cassistant'

SHARE='/usr/share/'$TYPE'd'
SERV='/lib/systemd/system/'$TYPE'.service'

if [[ -f $SHARE/runasts.sh ]]; then

	cat > $SHARE/runasts.sh << EOF
#!/bin/bash

INST_DIR="/opt/assistant"
. \$INST_DIR/scripts/get_version_os.sh

if [[ \$ID != "centos" && \$VER_TEMP != "8" ]]
then
    export LD_LIBRARY_PATH=\$INST_DIR/lib
fi


echo | tee -a /opt/assistant/log/daemon.log
echo "\$(date) Starting Assistant..." | tee -a /opt/assistant/log/daemon.log
exec \$INST_DIR/bin/asts \$1 >> /opt/assistant/log/daemon.log

exit 0
EOF
fi 


chmod +x $SHARE/runasts.sh

if [[ -f $SERV ]]; then 
	sed -i "s/\/cassistantd\/runasts.sh$/\/cassistantd\/runasts.sh --console/" $SERV
	sed -i "s/ExecStop=\/usr\/bin\/killall.*/ExecStop=\/usr\/bin\/killall asts astrct assistant master slave ffmpeg/" $SERV
	systemctl daemon-reload
	systemctl start $TYPE.service
fi

SUDO_FILE="/etc/sudoers.d/assistant"

echo "root ALL=(ALL) /opt/assistant/bin/" > $SUDO_FILE
echo "root ALL=(ALL) /opt/assistant/scripts/" >> $SUDO_FILE
echo "root ALL=(ALL) /sbin/setcap" >> $SUDO_FILE
echo "Defaults env_keep += \"DISPLAY XAUTHORITY\"" >> $SUDO_FILE

[[ -f $SUDO_FILE ]] && chmod 0400 $SUDO_FILE

change_lib

. /opt/assistant/scripts/setup.sh

cert --install
trusted --install

exit 0